define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var Data = require("$UI/system/components/justep/data/data");	
	var Request = require("$UI/system/lib/base/request");

	
	var Model = function(){
		this.callParent();
		this.queryEmpStart = true;  //避免data赋值时编码和名称查询循环执行（data.onDataChange事件）
		this.currMonth = "";
		this.orgNo = "0102";
		//定义一个observable变量,关联“查询方案”按钮的 bind-disable 属性
		this.btnQryFaVisable = justep.Bind.observable(false);
		this.md = null;
		this.gd = null;
	};
	
	
	//获取充值月份data数据
	Model.prototype.modelLoad = function(event){
		var _self = this;
		this.md = this.comp("mainData");;
		this.gd = this.comp("mainGrid");;
		var czMonData = this.comp("czMonData");
		if (czMonData.getCount() < 12){
		    biz.Request.sendBizRequest({
		    	"context" : this.getContext(),
		    	"action" : "queryCzMonthsAction",
		    	"callback" : function(res) {
		    		res.ignoreError = false;
		    		if (res.state) {
		    			var data = jQuery.parseJSON(res.response);
						czMonData.loadData(data);
						czMonData.first();
						_self.currMonth = czMonData.getValue('czMonth');
		    		}
		    	}   
		    });
		}
	};
	
    //自定义函数，根据员工编码获取员工信息
    Model.prototype.doQuyerEmpNameByNo = function(context,empNo,row){
	   // 构造参数
	   var param = new biz.Request.ActionParam();
	   param.setString("empNo", empNo);
	   Request.sendBizRequest({
           "context" : context,
           "action" : "queryEmpNameByNoAction",  
           "directExecute" : true,
           "parameters": param,
           "callback" : function(res) {
               res.ignoreError = false;
               if (res.state) {
            	   var data = jQuery.parseJSON(res.response);
            	   if (typeof(data.empName) == 'undefined' || !data.empName || data.empName == ''){
            		   row.val("empName", '');
					   row.val("ckType", '');
					   row.val("deptNo", '');
					   row.val("deptName", '');
					   row.val("orgNo", '');
					   row.val("orgName", '');
					   row.val("ycAmount", '');
					   row.val("scAmount", '');
					   justep.Util.hint("指定的员工不存在！", {type: 'error',position : 'middle'}); //, parent: hint_parent，hint_parent = this.getRootNode();
				   }else{
           			   row.val("empName", data.empName);
			           row.val("ckType", data.ckType);
			           row.val("deptNo", data.deptNo);
			           row.val("deptName", data.deptName);
			           row.val("orgNo", data.orgNo);
			           row.val("orgName", data.orgName);
			           row.val("ycAmount", data.ycAmount);
			           row.val("scAmount", data.ycAmount);
				   }
               }
           }
       });
    };

 
    //自定义函数，根据员工姓名 获取 员工信息
    Model.prototype.doQuyerEmpNoByName = function(context,empName,row){
	   var param = new biz.Request.ActionParam();
	   param.setString("empName", empName);
	   param.setString("orgNo", this.orgNo);
	   Request.sendBizRequest({
           "context" : context,
           "action" : "queryEmpNoByNameAction",  
           "directExecute" : true,
           "parameters": param,
           "callback" : function(res) {
               res.ignoreError = false;
               if (res.state) {
            	   var data = jQuery.parseJSON(res.response);
            	   if (typeof(data.empNo) == 'undefined' || !data.empNo || data.empNo == ''){
           			   row.val("empNo", '');	   
					   row.val("ckType", '');
					   row.val("deptNo", '');
					   row.val("deptName", '');
					   row.val("orgNo", '');
					   row.val("orgName", '');
					   row.val("ycAmount", '');
					   row.val("scAmount", '');
					   justep.Util.hint("指定的员工不存在！", {type: 'error',position : 'middle'}); //, parent: hint_parent
				   }else{
           			   row.val("empNo", data.empNo);	
			           row.val("ckType", data.ckType);
			           row.val("deptNo", data.deptNo);
			           row.val("deptName", data.deptName);
			           row.val("orgNo", data.orgNo);
			           row.val("orgName", data.orgName);
			           row.val("ycAmount", data.ycAmount);
			           row.val("scAmount", data.ycAmount);
				   }
               }
           }
       });
    };
    
    //新建
	Model.prototype.newBtnClick = function(event){

	};
    
    //{"operation":"mainData.delete"}，单行删除
    //delete按钮,多选删除
	Model.prototype.deleteBtnClick = function(event){
		var rowIDs = this.gd.getCheckeds();//获取多选选中行的id.返回的是list数组
		if(!rowIDs || !rowIDs.length)
		{
			this.md.deleteData();
			return;
		}
		var rows = [];
		var currRowId = this.md.getCurrentRowID();
		for(var i=0;i<rowIDs.length;i++){//遍历多选选中的行id 
		    if (rowIDs[i] != currRowId )
		    	rows.push(this.md.getRowByID(rowIDs[i])) ; //通过行id获取到行，并push到rows中 
		}
		debugger;
		rows.push(this.md.getCurrentRow());
		if (rows.length > 0){  
		    this.md.deleteData(rows);
		}
	};
    
    //批量充值
	Model.prototype.plczBtnClick = function(event){

	};
    
    //导入
	Model.prototype.btnDrClick = function(event){

	};
    
    //自定义查询
	Model.prototype.btnQryClick = function(event){

	};
    
    //重置查询
	Model.prototype.btnResetClick = function(event){

	};
    
	//保存前事件 data.onBeforeSave
	Model.prototype.mainDataBeforeSave = function(event){

	};
    
    //保存成功事件 data.onSaveCommit
    Model.prototype.mainDataSaveCommit = function(event){

	};

	//保存失败事件 data.onSaveError
	Model.prototype.mainDataSaveError = function(event){

	};
    
    //索引变化中事件 data.onIndexChanging
	Model.prototype.mainDataIndexChanging = function(event){
		var row = event.source.getCurrentRow();
		console.log("**mainDataIndexChanging,rowId="+event.source.getRowID()+",empNo="+(row ? row.val('empNo'):''));
		//event.cancel = true;
	};
    

    
    
    

	return Model;
});


